/********************************************************************
Table is designed without considering pivot point simply taking points
according to the requirement.
Therefore, translation of table involve translation of all points.
Scaling and Rotation will be done after translation.
********************************************************************/
#include <graphics.h>
#include <iostream.h>
#include <conio.h>
#include <math.h>

float round(float x)
{
	return x+0.5;
}
class Table
{
private:
		int xc, yc;//Center of the figure
		int xp, yp;//Pivot point for this figure
		int x1, x2, x3, x4;
		int y1, y2, y3, y4;
		int legLength;

public:
Table()
{
	xc=320, yc=240;//Center of the figure
	xp=0; yp=0;//Pivot point for this figure
	x1=310, x2=330, x3=330, x4=310;
	y1=233, y2=233, y3=247, y4=247;
	legLength=10;
}
void translate(int tx, int ty)
{
	xc+=tx;
	yc+=ty;
	x1+=tx;
	x2+=tx;
	x3+=tx;
	x4+=tx;
	y1+=ty;
	y2+=ty;
	y3+=ty;
	y4+=ty;
}
void rotate (float angle)
{
	int tempx=x1;
	x1=xc+(tempx-xc)*cos(angle)-(y1-yc)*sin(angle);
	y1=yc+(tempx-xc)*sin(angle)+(y1-yc)*cos(angle);
	tempx=x2;
	x2=xc+(tempx-xc)*cos(angle)-(y2-yc)*sin(angle);
	y2=yc+(tempx-xc)*sin(angle)+(y2-yc)*cos(angle);
	tempx=x3;
	x3=xc+(tempx-xc)*cos(angle)-(y3-yc)*sin(angle);
	y3=yc+(tempx-xc)*sin(angle)+(y3-yc)*cos(angle);
	tempx=x4;
	x4=xc+(tempx-xc)*cos(angle)-(y4-yc)*sin(angle);
	y4=yc+(tempx-xc)*sin(angle)+(y4-yc)*cos(angle);
}
void scale(int sx, int sy)
{
	x1=xc+(x1-xc)*sx;
	x2=xc+(x2-xc)*sx;
	x3=xc+(x3-xc)*sx;
	x4=xc+(x4-xc)*sx;
	y1=yc+(y1-yc)*sy;
	y2=yc+(y2-yc)*sy;
	y3=yc+(y3-yc)*sy;
	y4=yc+(y4-yc)*sy;
	legLength*=sy;
}
void draw()
{
	line (x1, y1, x2, y2);
	line (x2, y2, x3, y3);
	line (x3, y3, x4, y4);
	line (x4, y4, x1, y1);
	line (x1, y1, x1, y1+legLength);
	line (x2, y2, x2, y2+legLength);
	line (x3, y3, x3, y3+legLength);
	line (x4, y4, x4, y4+legLength);
}
};

void main()
{
	clrscr();
	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "c:\\tc\\bgi");
	Table table;
	table.draw();
	setcolor(CYAN);
	table.translate(15, 25);
	table.draw();
	table.translate(50, 75);
	table.scale(3,2);
	table.draw();
	table.translate(-100, 75);
	table.rotate(3.14/4);
	table.draw();
	getch();
	closegraph();
}